unit PropertiesUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TPropertiesForm = class(TForm)
    OKBtn: TButton;
    Bevel1: TBevel;
    CancelBtn: TButton;
    pfRG: TRadioGroup;
    GroupBox1: TGroupBox;
    WidthEdit: TEdit;
    Label3: TLabel;
    HeightEdit: TEdit;
    Label5: TLabel;
    StretchCB: TCheckBox;
    GroupBox2: TGroupBox;
    CompQualEdit: TEdit;
    ScrollBar1: TScrollBar;
    GroupBox3: TGroupBox;
    FileNameEdit: TEdit;
    procedure FormShow(Sender: TObject);
    procedure HeightEditKeyPress(Sender: TObject; var Key: Char);
    procedure WidthEditKeyPress(Sender: TObject; var Key: Char);
    procedure OKBtnClick(Sender: TObject);
    procedure CompQualEditKeyPress(Sender: TObject; var Key: Char);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ScrollBar1Scroll(Sender: TObject; ScrollCode: TScrollCode;
      var ScrollPos: Integer);
    procedure CompQualEditExit(Sender: TObject);
  private
    { Private declarations }
    procedure ChangeCompQual (i : byte);
  public
    { Public declarations }
  end;

var
  PropertiesForm: TPropertiesForm;

implementation

uses MainUnit, ExtrasUnit;

{$R *.DFM}

procedure TPropertiesForm.ChangeCompQual (i : byte);
begin
  ScrollBar1.Position := i;
  CompQualEdit.Text := IntToStr (i);
end;

procedure TPropertiesForm.FormShow(Sender: TObject);
begin
  with MainForm do begin
    FileNameEdit.Text := GetFileName;
    FileNameEdit.SetFocus;
    WidthEdit.Text := IntToStr (BitMap.Width);
    HeightEdit.Text := IntToStr (BitMap.Height);
    pfRG.ItemIndex := PixelFormatToInt (BitMap.PixelFormat);
    ChangeCompQual (CompQual);
  end;
end;

procedure TPropertiesForm.HeightEditKeyPress(Sender: TObject; var Key: Char);
begin
  NumOnly (Key);
end;

procedure TPropertiesForm.WidthEditKeyPress(Sender: TObject; var Key: Char);
begin
  NumOnly (Key);
end;

procedure TPropertiesForm.OKBtnClick(Sender: TObject);
var BitMap2 : TBitMap;
begin
  with MainForm do begin
    if StretchCB.Checked then begin
      BitMap2 := TBitMap.Create;
      BitMap2.Assign (BitMap);
    end;

    BitMap.Width := StrToInt (WidthEdit.Text);
    BitMap.Height := StrToInt (HeightEdit.Text);

    if StretchCB.Checked then begin
      //the warning this line gives is idiodic
      BitMap.Canvas.StretchDraw (Rect (0, 0, StrToInt (WidthEdit.Text), StrToInt (HeightEdit.Text)),
                                 BitMap2);
      BitMap2.Free;
    end;

    BitMap.PixelFormat := IntToPixelFormat (pfRG.ItemIndex);

    AssignFileName (FileNameEdit.Text);
    ChangeCompQual (StrToInt (CompQualEdit.Text));
    CompQual := ScrollBar1.Position;
    PaintImage;
  end;
end;

procedure TPropertiesForm.CompQualEditKeyPress(Sender: TObject;
  var Key: Char);
begin
  NumOnly (Key);
end;

procedure TPropertiesForm.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if not (ssAlt in Shift) then exit;

  case LwrChr (Key) of
    'j' : CompQualEdit.SetFocus;
    'f' : FileNameEdit.SetFocus;
  end;
end;

procedure TPropertiesForm.ScrollBar1Scroll(Sender: TObject;
  ScrollCode: TScrollCode; var ScrollPos: Integer);
begin
  ChangeCompQual (ScrollBar1.Position);
end;

procedure TPropertiesForm.CompQualEditExit(Sender: TObject);
begin
  ChangeCompQual (StrToInt (CompQualEdit.Text));
end;


end.

